// PID parameters
int Kp=-250; //250
int Ki=0;
int Kd=-1500; //1500
//const int maximum = 60; //40
  
//valori che funzionano:
// Kp=250 Kd=800 vel=40
// kp=240 Kd=700 vel=50
// Kp=200 kd=900 vel=60 ---> non riesce a curvare abbastanza
// kp=230 Kd=900-1200 vel=50
// kp=230 Kd=2500 vel=50 - perde leggermente la linea
// kp=250 kd=1500 vel1=50, vel2=35 per angoli


// follow the black line - segui la linea nera

void follow_segment()
{
  long integral=0;

  //posizione = qtrrc.readLine(sensors); // read the IR sensors - leggi i sensori IR
  
  long int proportional = posizione;
  int P = proportional * Kp/1000; // Proportional parameter

  long int derivative = proportional - last_proportional; //Derivative parameter
  if (primo==0) // firt cycle set derivative to zero - al primo giro imposta il derivativo a zero
    { 
      primo=1;
      derivative=0;
    }
  int D=derivative*Kd/1000;
  integral += proportional;
  int I=integral*Ki/1000; //integral parameter

  // Remember the last position - ricorda l'ultima posizione
  last_proportional = proportional;


  int PID =P + I + D; //calculate the PID

  #ifdef USB
  // print some values on the serial port - scrivi qualche valore sulla seriale
  unsigned char zz;
   for (zz = 0; zz < NUM_SENSORS; zz++)
    {
      if (sensors[zz]<10)
      Serial.print("00");
      if (sensors[zz]>=10 && sensors[zz]<100)
      Serial.print("0");
      if (sensors[zz]==1000)
      sensors[zz]--;
      Serial.print(int(sensors[zz]));
      Serial.print(' ');
    }
    Serial.print("  position: "); 
    Serial.print(posizione); 
    Serial.print("  P:");
    Serial.print(P);
    Serial.print("  I:");
    Serial.print(I);
    Serial.print("  D:");
    Serial.print(D);
    Serial.print("  PID:"); 
    Serial.print(PID);
  #endif
  
  actualSpeed=int(-float(posizione)/800.0*float(maximumSpeed-minimumSpeed) + maximumSpeed);
  maximum=actualSpeed;
  // set the values for the motors based on the PID gain - setta i valori del motore basati sul PID
    // the maximum speed
    int correzPID=15;
     if (PID > 0){
       if (PID > maximum+correzPID) PID=maximum+correzPID;
       motor_speed2(motor_B,maximum);
       motor_speed2(motor_A,maximum-PID);
       #ifdef USB
      Serial.print("  Motore_B:");    Serial.print(maximum);
    Serial.print("  Motore_A:");     Serial.print(maximum-PID);
      #endif
      }
      else {
       if (PID < -(maximum+correzPID)) PID=-(maximum+correzPID);
       motor_speed2(motor_B,maximum+PID);
       motor_speed2(motor_A,maximum);
      #ifdef USB
      Serial.print("  Motore_B:");    Serial.print(maximum+PID);
    Serial.print("  Motore_A:");     Serial.print(maximum);
     #endif
      }

    Serial.println("");


}


// ------------------ stop the robot - ferma il robottino  -----------------------

void stopMotors(){
  motor_brake(motor_A);
  motor_brake(motor_B);
}


// ------------------ Motor driver mgmt routines - routine per gestire i motori  -----------------------

 
void motor_speed2(boolean motor, char speed) { //speed from 0 to 100
  if (motor == motor_A) // the wiring for motor A are inverted
   speed = -speed; 
  byte PWMvalue=0;
  PWMvalue = map(abs(speed),0,100,5,255); //anything below 5 is very weak
  if (speed >= 0)
    motor_speed(motor,0,PWMvalue);
  else if (speed < 0)
    motor_speed(motor,1,PWMvalue);
  else {
    motor_coast(motor);
  }
}
void motor_speed(boolean motor, boolean direction, byte speed) { //speed from 0 to 255
  if (motor == motor_A) {
    if (direction == 0) {
      digitalWrite(out_A_IN1,HIGH);
      digitalWrite(out_A_IN2,LOW);
    } else {
      digitalWrite(out_A_IN1,LOW);
      digitalWrite(out_A_IN2,HIGH);
    }
    analogWrite(out_A_PWM,speed);
  } else {
    if (direction == 0) {
      digitalWrite(out_B_IN1,HIGH);
      digitalWrite(out_B_IN2,LOW);
    } else {
      digitalWrite(out_B_IN1,LOW);
      digitalWrite(out_B_IN2,HIGH);
    }
    analogWrite(out_B_PWM,speed);
  }
}

// stand-by motor
void motor_standby(boolean state) { //low power mode
  if (state == true)
    digitalWrite(out_STBY,LOW);
  else
    digitalWrite(out_STBY,HIGH);
}

// stop the motors
void motor_brake(boolean motor) {
  if (motor == motor_A) {
    digitalWrite(out_A_IN1,HIGH);
    digitalWrite(out_A_IN2,HIGH);
  } else {
    digitalWrite(out_B_IN1,HIGH);
    digitalWrite(out_B_IN2,HIGH);
  }
}

// motors coast - fai girare i motori in folle
void motor_coast(boolean motor) {
  if (motor == motor_A) {
    digitalWrite(out_A_IN1,LOW);
    digitalWrite(out_A_IN2,LOW);
    digitalWrite(out_A_PWM,HIGH);
  } else {
    digitalWrite(out_B_IN1,LOW);
    digitalWrite(out_B_IN2,LOW);
    digitalWrite(out_B_PWM,HIGH);
  }
} 


